"use strict";Object.defineProperty(exports, "__esModule", {value: true});




var _chunkRBV2IRJMjs = require('./chunk-RBV2IRJM.js');


var _chunkFXYZ3O43js = require('./chunk-FXYZ3O43.js');

// src/core/transform.ts
var _compilersfc = require('@vue/compiler-sfc');
var transform = (code, id) => {
  if (!code.includes(_chunkFXYZ3O43js.DEFINE_OPTIONS_NAME))
    return;
  const sfc = _chunkRBV2IRJMjs.parseSFC.call(void 0, code, id);
  if (!sfc.scriptSetup)
    return;
  if (!sfc.scriptSetup.scriptSetupAst) {
    sfc.scriptSetup = _compilersfc.compileScript.call(void 0, sfc, {
      id
    });
  }
  const { script, scriptSetup, source } = sfc;
  const nodes = _chunkRBV2IRJMjs.filterMarco.call(void 0, scriptSetup);
  if (nodes.length === 0)
    return;
  else if (nodes.length > 1)
    throw new SyntaxError(`duplicate ${_chunkFXYZ3O43js.DEFINE_OPTIONS_NAME}() call`);
  if (script)
    throw new SyntaxError(`${_chunkFXYZ3O43js.DEFINE_OPTIONS_NAME} cannot be used, with both script and script-setup.`);
  const node = nodes[0];
  const arg = node.arguments[0];
  if (!(node.arguments.length === 1 && arg.type === "ObjectExpression")) {
    throw new SyntaxError(`${_chunkFXYZ3O43js.DEFINE_OPTIONS_NAME}() arguments error`);
  }
  if (_chunkRBV2IRJMjs.hasPropsOrEmits.call(void 0, arg)) {
    throw new SyntaxError(`${_chunkFXYZ3O43js.DEFINE_OPTIONS_NAME}() please use defineProps or defineEmits instead.`);
  }
  _chunkRBV2IRJMjs.checkInvalidScopeReference.call(void 0, arg, _chunkFXYZ3O43js.DEFINE_OPTIONS_NAME, scriptSetup);
  const argText = scriptSetup.loc.source.slice(arg.start, arg.end);
  const s = new (0, _compilersfc.MagicString)(source);
  s.prepend(`<script lang="${scriptSetup.attrs.lang || "js"}">
export default ${argText}<\/script>
`);
  s.remove(scriptSetup.loc.start.offset + node.start, scriptSetup.loc.start.offset + node.end);
  return {
    code: s.toString(),
    get map() {
      return s.generateMap({
        source: id,
        includeContent: true
      });
    }
  };
};



exports.transform = transform;
//# sourceMappingURL=chunk-D44ATEHN.js.map